;///////////////////////////////////////////////////////////////////////////////////////////////////////////////
;TournamentBlitz Event Managment System v2.0 BlitzBasic SDK
;///////////////////////////////////////////////////////////////////////////////////////////////////////////////

Const TBEMS_RESPONSE_OK=1
Const TBEMS_RESPONSE_ENTRYREGISTER=2
Const TBEMS_RESPONSE_NOACCESS=0
Const TBEMS_RESPONSE_ENTRYSUCCESS=1
Const TBEMS_RESPONSE_NOCREDITS=-1
Const TBEMS_RESPONSE_EVENTFULL=-2
Const TBEMS_RESPONSE_NODATABASE=-256
Const TBEMS_RESPONSE_TRADESUCCESSFUL=1
Const TBEMS_RESPONSE_TRADEREJECTED=-1

;TBEMS Object Group
Global TBEMS_EVENT_MAX$=256
Global TBEMSSessionAdvertisement$
Global TBEMSSessionTimeOut$
Global TBEMSSessionTimer$
Global TBEMSSessionUname$;stores username required for communications with tournamentblitz
Global TBEMSSessionPass$;stores user password required for communications with tournamentblitz
Global TBEMSSessionActive$;stores login response returned by TBEMSList() Function. Valid Response: TBEMS_RESPONSE_OK,TBEMS_RESPONSE_ENTRYREGISTER,TBEMS_RESPONSE_NOACCESS
Global TBEMSSessionLanguage$="en-us"
Global TBEMSGameID$;stores official game license key used as Game ID, must be acquired from TournamentBlitz.com required for communications with tournamentblitz
Global TBEMSGameEventType$
Global TBEMSGamePlay$;stores entry response returned by TBEMSEnter() Function. Valid Response: TBEMS_RESPONSE_ENTRYSUCCESS,TBEMS_RESPONSE_NOCREDITS,TBEMS_RESPONSE_EVENTFULL
Global TBEMSGameScore$;stores gamescore submitted by TBEMSResults() Function
Global TBEMSEventKey$
Global TBEMSEventsMax=24;stores maximum number of events
Global TBEMSEvents
Global TBEMSEventMessage$
Global TBEMSEventFinalScore$
Global TBEMSEventLeader$ 
Global TBEMSEventSelectedIndex$;stores event selected by TBEMSEventID Array
Global TBEMSPlayersMax=255
Global TBEMSPlayers
Global TBEMSPlayerEvents$
Global TBEMSPlayerCredits$
Global TBEMSPlayerTbpoints$
Global TBEMSPlayerTopScore$
Global TBEMSPlayerTopuname$
Global TBEMSPlayerRegister$
Global TBEMSRTPlayerUname$
Global TBEMSRTPlayerPass$
Global TBEMSCommerceuname$
Global TBEMSCommercepass$
Global TBEMSCommercecredits$
Global TBEMSNetEventID$
Global TBEMSNetPingIP$

;TBEMSEvent Arrays
Dim TBEMSEventID$(TBEMSEventsMax)
Dim TBEMSEventName$(TBEMSEventsMax)
Dim TBEMSEventIP$(TBEMSEventsMax)
Dim TBEMSEventType$(TBEMSEventsMax)
Dim TBEMSEventMinSkill$(TBEMSEventsMax)
Dim TBEMSEventEntryFee$(TBEMSEventsMax)
Dim TBEMSEventEntryFeeType$(TBEMSEventsMax)
Dim TBEMSEventPlayerBalance$(TBEMSEventsMax)
Dim TBEMSEventMaxPlayers$(TBEMSEventsMax)
Dim TBEMSEventCurrentPlayers$(TBEMSEventsMax)
Dim TBEMSEventPrize$(TBEMSEventsMax)
Dim TBEMSEventValue$(TBEMSEventsMax)
Dim TBEMSEventValueDescription$(TBEMSEventsMax)


;TBEMSPlayer Arrays
Dim TBEMSPlayerScore$(TBEMSPlayersMax)
Dim TBEMSPlayeruname$(TBEMSPlayersMax)
Dim TBEMSPlayerBonus$(TBEMSPlayersMax)
Dim TBEMSPlayerRank$(TBEMSPlayersMax)	
	
;///////////////////////////////////////////////////////////////////////////////////////////////////////////////
;TBEMS OPERATION FUNCTIONS 
;///////////////////////////////////////////////////////////////////////////////////////////////////////////////
Function TBEMSStart(TBEMSGame_ID$,TBEMSPlayerMaximum=255,TBEMSEventMaximum=24)
	;Purpose: Creates new instance of TBEMS Object
	;Parameters: 
	;	TBEMSServer -  TournamentBlitz Database Server
	;	TBEMSGameType- TournamentBlitz or CoinOp Service 
	;Returns TBEMS Object

	TBEMSGameID$=TBEMSGame_ID$
	TBEMSEventsMax=TBEMSEventMaximum
	TBEMSPlayersMax=TBEMSPlayerMaximum
	
	Dim TBEMSEventID$(TBEMSEventsMax)
	Dim TBEMSEventName$(TBEMSEventsMax)
	Dim TBEMSEventIP$(TBEMSEventsMax)
	Dim TBEMSEventType$(TBEMSEventsMax)
	Dim TBEMSEventMinSkill$(TBEMSEventsMax)
	Dim TBEMSEventEntryFee$(TBEMSEventsMax)
	Dim TBEMSEventEntryFeeType$(TBEMSEventsMax)
	Dim TBEMSEventPlayerBalance$(TBEMSEventsMax)
	Dim TBEMSEventMaxPlayers$(TBEMSEventsMax)
	Dim TBEMSEventCurrentPlayers$(TBEMSEventsMax)
	Dim TBEMSEventPrize$(TBEMSEventsMax)
	Dim TBEMSEventValue$(TBEMSEventsMax)
	Dim TBEMSEventValueDescription$(TBEMSEventsMax)
	
	Dim TBEMSPlayerScore$(TBEMSPlayersMax)
	Dim TBEMSPlayeruname$(TBEMSPlayersMax)
	Dim TBEMSPlayerBonus$(TBEMSPlayersMax)
	Dim TBEMSPlayerRank$(TBEMSPlayersMax)	
	
End Function

Function TBEMSStop()
	;Purpose: Removes TBEMS Object
	;Parameters: None
	;Returns : None
End Function

Function TBEMSRequest(tbemspoststring$)
	;Purpose: Opens HTTP connection to Tournament BLITZ Server Page and Posts Variables Values.
	;Parameters: None
	;Returns : None	
    tbemsservertcptream=OpenTCPStream("tournamentblitz.hpquest.com",80)
    If Not tbemsservertcptream RuntimeError "Failed To Connect to TournamentBlitz.com Server"
    WriteLine tbemsservertcptream, "POST /TBEMS.php HTTP/1.0"
    WriteLine tbemsservertcptream, "Accept: */*"
    WriteLine tbemsservertcptream, "Accept-Language: "+TBEMSSessionLanguage$
    WriteLine tbemsservertcptream, "Accept-Encoding: gzip, deflate"
    WriteLine tbemsservertcptream, "User-Agent: TBEMS.bb"
    WriteLine tbemsservertcptream, "Content-Type: application/x-www-form-urlencoded"
    WriteLine tbemsservertcptream, "Host: tournamentblitz.hpquest.com"
    WriteLine tbemsservertcptream, "Content-Length: "+Str(Len(tbemspoststring$))
    WriteLine tbemsservertcptream, ""
    WriteLine tbemsservertcptream, tbemspoststring$
	DebugLog(tbemspoststring$)
	While Not Eof(tbemsservertcptream)
		Select ReadLineDebug$(tbemsservertcptream)
			Case "SessionAdvertisement" TBEMSSessionAdvertisement=ReadLineDebug$(tbemsservertcptream)
			Case "SessionTimeout" TBEMSSessionTimeout=ReadLineDebug$(tbemsservertcptream)
			Case "SessionTimer" TBEMSSessionTimer=ReadLineDebug$(tbemsservertcptream)
			Case "SessionUname" TBEMSSessionUname=ReadLineDebug$(tbemsservertcptream)
			Case "SessionPass" TBEMSSessionPass=ReadLineDebug$(tbemsservertcptream)
			Case "SessionActive" TBEMSSessionActive=ReadLineDebug$(tbemsservertcptream)
			Case "SessionLanguage" TBEMSSessionLanguage=ReadLineDebug$(tbemsservertcptream)
			Case "GamePlay" TBEMSGamePlay=ReadLineDebug$(tbemsservertcptream)
			Case "GameScore" TBEMSGameScore=ReadLineDebug$(tbemsservertcptream)
			Case "EventKey" TBEMSEventKey=ReadLineDebug$(tbemsservertcptream)	
			Case "EventMessage" TBEMSEventMessage=ReadLineDebug$(tbemsservertcptream)	
			Case "EventFinalScore" TBEMSEventFinalScore=ReadLineDebug$(tbemsservertcptream)
			Case "EventLeader" TBEMSEventLeader=ReadLineDebug$(tbemsservertcptream)
			Case "EventList" TBEMSEvents=0 
			Case "EventItem" TBEMSEvents=TBEMSEvents+1
			Case "EventID" TBEMSEventID(TBEMSEvents)=ReadLineDebug$(tbemsservertcptream)
			Case "EventName" TBEMSEventName(TBEMSEvents)=ReadLineDebug$(tbemsservertcptream)
			Case "EventHostIP"  TBEMSEventIP(TBEMSEvents)=ReadLineDebug$(tbemsservertcptream)
			Case "EventType" TBEMSEventType(TBEMSEvents)=ReadLineDebug$(tbemsservertcptream)
			Case "EventMinSkill" TBEMSEventMinSkill(TBEMSEvents)=ReadLineDebug$(tbemsservertcptream)
			Case "EventEntryFee" TBEMSEventEntryFee(TBEMSEvents)=ReadLineDebug$(tbemsservertcptream)
			Case "EventEntryFeeType" TBEMSEventEntryFeeType(TBEMSEvents)=ReadLineDebug$(tbemsservertcptream)
			Case "EventPlayerBalance" TBEMSEventPlayerBalance(TBEMSEvents)=ReadLineDebug$(tbemsservertcptream)
			Case "EventPrize" TBEMSEventPrize(TBEMSEvents)=ReadLineDebug$(tbemsservertcptream)
			Case "EventMaxPlayers" TBEMSEventMaxPlayers(TBEMSEvents)=ReadLineDebug$(tbemsservertcptream)
			Case "EventCurrentPlayers" TBEMSEventCurrentPlayers(TBEMSEvents)=ReadLineDebug$(tbemsservertcptream)
			Case "EventValue" TBEMSEventValue(TBEMSEvents)=ReadLineDebug$(tbemsservertcptream)
			Case "PlayerRegister" TBEMSPlayerRegister=ReadLineDebug$(tbemsservertcptream)
			Case "PlayerEvents" TBEMSPlayerEvents=ReadLineDebug$(tbemsservertcptream)
			Case "PlayerCredits" TBEMSPlayerCredits=ReadLineDebug$(tbemsservertcptream)
			Case "PlayerTbpoints" TBEMSPlayerTbpoints=ReadLineDebug$(tbemsservertcptream)
			Case "PlayerTopScore" TBEMSPlayerTopScore=ReadLineDebug$(tbemsservertcptream)
			Case "PlayerTopuname" TBEMSPlayerTopuname$=ReadLineDebug$(tbemsservertcptream)
			Case "PlayerList" TBEMSPlayers=0
			Case "PlayerItem" TBEMSPlayers=TBEMSPlayers+1
			Case "PlayerScore" TBEMSPlayerScore(TBEMSPlayers)=ReadLineDebug$(tbemsservertcptream)
			Case "PlayerUname" TBEMSPlayerUname(TBEMSPlayers)=ReadLineDebug$(tbemsservertcptream)						
			Case "PlayerBonus" TBEMSPlayerBonus(TBEMSPlayers)=ReadLineDebug$(tbemsservertcptream)
			Case "PlayerRank" 	TBEMSPlayerRank(TBEMSPlayers)=ReadLineDebug$(tbemsservertcptream)
 			Case "NetPing" TBEMSNetPingIP$=ReadLineDebug$(tbemsservertcptream)
		End Select
	Wend
	CloseTCPStream(tbemsservertcptream)
End Function

;///////////////////////////////////////////////////////////////////////////////////////////////////////////////
;TBEMS UI FUNCTIONS
;///////////////////////////////////////////////////////////////////////////////////////////////////////////////
Function TBEMSList()
	;Purpose: Logins into TournamentBlitz Server and Retrieves Event List. Login response is stored in TBEMSSessionActive Variable
	;	If TBEMSSessionActive=TBEMS_RESPONSE_OK, a list of Events is stored in TBEMSEvent Array Group
	;	If Login all fails, Player should be presented with a Fail Alert Dialog and retuned to Login Dialog.
	;Parameters: None
	;Return: TBEMSSessionActive= TBEMS_RESPONSE_OK|TBEMS_RESPONSE_ENTRYREGISTER|TBEMS_RESPONSE_NOACCESS
	TBEMSRequest("option=list&uname="+TBEMSSessionUname$+"&pass="+TBEMSSessionPass$+"&gameID="+TBEMSGameID$+"&eventtype="+TBEMSGameEventType$)
End Function

Function TBEMSEntry()
	;Purpose: Submits Entry into Tournament. Prior to Calling this Function the Player a presented a dialog to confirm or cancel entry. 
	;	The dialog should  display event fee, available credits/tbpoints, and balance
	;Parameters: None
	;Return: TBEMSGamePlay= TBEMS_RESPONSE_ENTRYSUCCESS|TBEMS_RESPONSE_NOCREDITS|TBEMS_RESPONSE_EVENTFULL
	TBEMSRequest("option=entry&uname="+TBEMSSessionUname$+"&pass="+TBEMSSessionPass$+"&gameID="+TBEMSGameID$+"&eventtype="+TBEMSGameEventType$+"&eventID="+TBEMSEventID(TBEMSEventSelectedIndex))
End Function

Function TBEMSResults()
	;Purpose: Submits Score when GameOver and retrieves Event Results. 
	;	Results are stored in TBEMSPlayer Array Group
	;Parameters: None
	;Return: None
	TBEMSRequest("option=results&uname="+TBEMSSessionUname$+"&pass="+TBEMSSessionPass$+"&eventkey="+TBEMSEventkey$+"&score="+TBEMSGameScore$)
End Function

Function TBEMSRegister()
	;Purpose: Creates a TournamentBlitz Player 'Scoreboard' Account. 
	;	Login uname and Password is persistant until logout. If Login all fails, Player should be presented with a Fail Alert Dialog 
	;	and retuned to Login Dialog.
	;Parameters: None
	;Return:  1:Username Accepted, -1:Username Taken
	;Note: 
	TBEMSRequest("option=register&uname="+TBEMSSessionUname$+"&pass="+TBEMSSessionPass$+"&gameID="+TBEMSGameID$)
End Function

Function TBEMSStats()
	;Purpose: Requests Stats History List for Game. Game Results storing Player results in stored in TBEMS_player.TBEMSPlayerItem(n)
	;Parameters: None
	;Return: None
	TBEMSRequest("option=stats&uname="+TBEMSSessionUname$+"&pass="+TBEMSSessionPass$+"&gameID="+TBEMSGameID$)
End Function

Function TBEMSReset()
	;Purpose:  Sets uname and Password to nil. Player should be returned to Login Dialog
	;Parameters:  None
	;Return:  None
	TBEMSSessionUname$=""
	TBEMSSessionPass$=""
	TBEMSSessionActive=False
End Function

;///////////////////////////////////////////////////////////////////////////////////////////////////////////////
;Real-Time Score Update
;Server is client
;///////////////////////////////////////////////////////////////////////////////////////////////////////////////
Function TBEMSRTStart(tbemsrtplayeruname$,tbemsrtplayerpass$)
	;Purpose: Tournament Start
	;Parameters: None
	;Return: None
	TBEMSRequest("option=rtstart&uname="+TBEMSSessionUname$+"&pass="+TBEMSSessionPass$+"&gameID="+TBEMSGameID$+"&rtplayeruname="+tbemsrtplayeruname$+"&rtplayerpass="+tbemsrtplayerpass$)
End Function

Function TBEMSRTStop(tbemsrtplayeruname$,tbemsrtplayerpass$)
	;Purpose: Tournament Stop
	;Parameters: None
	;Return: None
	TBEMSRequest("option=rtstop&uname="+TBEMSSessionUname$+"&pass="+TBEMSSessionPass$+"&gameID="+TBEMSGameID$+"&rtplayeruname="+tbemsrtplayeruname$+"&rtplayerpass="+tbemsrtplayerpass$)
End Function

Function TBEMSRTEnter(tbemsrtplayeruname$,tbemsrtplayerpass$)
	;Purpose: Player Enters the Tournament
	;Parameters: None
	;Return: None
	TBEMSRequest("option=rtenter&uname="+TBEMSSessionUname$+"&pass="+TBEMSSessionPass$+"&gameID="+TBEMSGameID$+"&rtplayeruname="+tbemsrtplayeruname$+"&rtplayerpass="+tbemsrtplayerpass$)	
End Function

Function TBEMSRTExit(tbemsrtplayeruname$,tbemsrtplayerpass$)
	;Purpose: Player Exits the Tournament
	;Parameters: None
	;Return: None
	TBEMSRequest("option=rtexit&uname="+TBEMSSessionUname$+"&pass="+TBEMSSessionPass$+"&gameID="+TBEMSGameID$+"&rtplayeruname="+tbemsrtplayeruname$+"&rtplayerpass="+tbemsrtplayerpass$)	
End Function

Function TBEMSRTUpdate(tbemsrtplayeruname$,tbemsrtplayerpass$)
	;Purpose: Tournament Score update
	;Parameters: None
	;Return: None
	TBEMSRequest("option=rtupdate&uname="+TBEMSSessionUname$+"&pass="+TBEMSSessionPass$+"&gameID="+TBEMSGameID$+"&rtplayeruname="+tbemsrtplayeruname$+"&rtplayerpass="+tbemsrtplayerpass$+"&eventkey="+TBEMSEventkey$+"&score="+TBEMSGameScore$)	
End Function

;///////////////////////////////////////////////////////////////////////////////////////////////////////////////
;In-Game Commerce
;///////////////////////////////////////////////////////////////////////////////////////////////////////////////
Function TBEMSCommerceTrade(tbemscommerceunamefrom$,tbemscommercepassfrom$,tbemscommerceunameto$,tbemscommercepassto$,tbemscommerceitemid)
	;Purpose: Transfers Credits from Player Pass to Second Party. 
	;	Only Two Party Transfer Supported. Requires Both Parties Username And Password for Validation.
	;	Each transfer item must have a unique id;
	;Parameters:  None
	;Return:  TBEMS_RESPONSE_TRADESUCCESSFUL, TBEMS_RESPONSE_TRADEREJECTED
	TBEMSRequest("option=commercetrade&uname="+TBEMSSessionUname$+"&pass="+TBEMSSessionPass$+"&gameID="+TBEMSGameID$+"&commerceunamefrom="+tbemscommerceunamefrom$+"&commercepassfrom="+tbemscommercepassfrom$+"&commerceunameto="+tbemscommerceunameto$+"&commercepassto="+tbemscommercepassto$+"&commerceitemID="+tbemscommerceitemid)
End Function

;///////////////////////////////////////////////////////////////////////////////////////////////////////////////
;Net
;///////////////////////////////////////////////////////////////////////////////////////////////////////////////
Function TBEMSNetList()
	;Purpose: Lists Net Servers applicable to game
	;Parameters:  None
	;Return:  None
	TBEMSRequest("option=tbnetlist&uname="+TBEMSSessionUname$+"&pass="+TBEMSSessionPass$+"&gameID="+TBEMSGameID$)
End Function

Function TBEMSNetAdd()
	;Purpose: Registers Game Server to Net Server 
	;Parameters: None
	;Return:  None
	TBEMSRequest("option=tbnetadd&uname="+TBEMSSessionUname$+"&pass="+TBEMSSessionPass$+"&gameID="+TBEMSGameID$+"&eventID="+TBEMSNetEventID$)
End Function

Function TBEMSNetRefresh()
	;Purpose: 
	;Parameters:  None
	;Return:  None
	TBEMSRequest("option=tbnetrefresh&uname="+TBEMSSessionUname$+"&pass="+TBEMSSessionPass$+"&gameID="+TBEMSGameID$+"&eventID="+TBEMSNetEventID$)
End Function

Function TBEMSNetRemove()
	;Purpose: 
	;Parameters: None
	;Return:  None
	TBEMSRequest("option=tbnetremove&uname="+TBEMSSessionUname$+"&pass="+TBEMSSessionPass$+"&gameID="+TBEMSGameID$+"&eventID="+TBEMSNetEventID$)
End Function

Function TBEMSNetPing()
	;Purpose: 
	;Parameters:  None
	;Return:  None
	TBEMSRequest("option=tbnetping&uname="+TBEMSSessionUname$+"&pass="+TBEMSSessionPass$+"&gameID="+TBEMSGameID$+"&eventID="+TBEMSNetEventID$)
End Function

;///////////////////////////////////////////////////////////////////////////////////////////////////////////////
;testing
;///////////////////////////////////////////////////////////////////////////////////////////////////////////////
Function TBEMSTest()
	;Purpose: Transfers Credits from Player Pass to Second Party. 
	;	Only Two Party Transfer Supported. Requires Both Parties Username And Password for Validation.
	;Parameters:  None
	;Return: None
	TBEMSRequest("option=test&uname="+TBEMSSessionUname$+"&pass="+TBEMSSessionPass$+"&gameID="+TBEMSGameID$)
End Function

Function ReadLineDebug$(stream)
	txt$=ReadLine(stream)
	DebugLog(txt$)
	Return txt$
End Function